#include "ir_sending.h"
#include <IRremoteESP8266.h>
#include <IRsend.h>

const uint16_t kIrLed = 4;  // ESP8266 GPIO pin to use. Recommended: 4 (D2).
IRsend irsend(kIrLed);

void ir_sending(String t_state) {
  irsend.begin();

  String keys;
  char str[300];
  t_state.toCharArray(str, 300);

  char* token = strtok(str, "-");

  String dev;
  String rep;
  while (token != NULL) {
    keys= String(token);
    if (keys[0] == '0' && keys[1] == 'x') {
      rece(dev, keys, rep);
      rep = '1';
    } else if (keys[0] == 'R' && isDigit(keys[1])) {
      rep = keys;
    } else {
      dev = keys;
    }
    token = strtok(NULL, "-");
  }
}
void rece(String device, String val, String repeat) {
  char valch[50];
  val.toCharArray(valch, 50);
  repeat.remove(0, 1);
  if (repeat == "") {
    repeat = '1';
  }
  long unsigned int b = strtoul(valch, NULL, 16);
  Serial.println(device + "  " + val + "  " + b + "  Rep=" + repeat);
  
  if (device == "STB") {
    for (int i = 0; i < repeat.toInt(); i++) {
      irsend.sendRC6(b, 24);
      delay(160);

    }
  } else if (device == "TV") {
    for (int i = 0; i < repeat.toInt(); i++) {
      irsend.sendNEC(b, 32, 1);
      delay(160);

    }
  }
}
